%define testname freedesktop-categories

Name: repocop-unittest-%testname
Version: 0.05
Release: alt1
BuildArch: noarch
Packager: Igor Yu. Vlasenko <viy@altlinux.org>

Summary: freedesktop tests for repocop test platform
Group: Development/Other
License: GPL or Artistic
#Url: 
Requires: repocop

#Source: %name-%version.tar

BuildRequires: perl-devel

%description
freedesktop intergration tests for repocop test platform.
It includes: 
   freedesktop-categories test

%prep
#%setup -q

%build
cat > test <<'EOF'
#!/usr/bin/perl
my %L1=map {$_=>1} qw/
AudioVideo
Audio
Video
Development
Education
Game
Graphics
Network
Office
Settings
System
Utility
/;
my %L2=map {$_=>1} qw/
Building
Debugger
IDE
GUIDesigner
Profiling
RevisionControl
Translation
Calendar
ContactManagement
Database
Dictionary
Chart
Email
Finance
FlowChart
PDA
ProjectManagement
Presentation
Spreadsheet
WordProcessor
2DGraphics
VectorGraphics
RasterGraphics
3DGraphics
Scanning
OCR
Photography
Publishing
Viewer
TextTools
DesktopSettings
HardwareSettings
Printing
PackageManager
Dialup
InstantMessaging
Chat
IRCClient
FileTransfer
HamRadio
News
P2P
RemoteAccess
Telephony
TelephonyTools
VideoConference
WebBrowser
WebDevelopment
Midi
Mixer
Sequencer
Tuner
TV
AudioVideoEditing
Player
Recorder
DiscBurning
ActionGame
AdventureGame
ArcadeGame
BoardGame
BlocksGame
CardGame
KidsGame
LogicGame
RolePlaying
Simulation
SportsGame
StrategyGame
Art
Construction
Music
Languages
Science
ArtificialIntelligence
Astronomy
Biology
Chemistry
ComputerScience
DataVisualization
Economy
Electricity
Geography
Geology
Geoscience
History
ImageProcessing
Literature
Math
NumericalAnalysis
MedicalSoftware
Physics
Robotics
Sports
ParallelComputing
Amusement
Archiving
Compression
Electronics
Emulator
Engineering
FileTools
FileManager
TerminalEmulator
Filesystem
Monitor
Security
Accessibility
Calculator
Clock
TextEditor
Documentation
Core
/;
my $STATUS="skip";
my @message;
foreach my $file (glob "$ENV{REPOCOP_PKG_ROOT}%_desktopdir/*.desktop") {
    my $filename=$file;
    $filename=~s!^.*/!!;
    my $categories=`grep '^Categories' '$file'`;
    if ($categories and system("grep ^OnlyShowIn '$file' >/dev/null")!=0) {
        $categories=~s/^Categories=//;
        $categories=~s/\s*$//;
	my @categories=grep {$_} split /;/, $categories;
	unless (grep {$L1{$_}} @categories) {
	       $STATUS="fail";
	       push @message, "Main Categories consist of those categories that every conforming desktop environment MUST support.(http://standards.freedesktop.org/menu-spec/latest/apa.html). None found in $filename. please, fix."
	}
	unless (grep {$L2{$_}} @categories) {
	       $STATUS="warn" unless $STATUS eq "fail";
	       push @message, "Menu-related Additional Categories (http://standards.freedesktop.org/menu-spec/latest/apa.html) not found in $filename. Please add it or report a bug against this test if you already have registered one (not including menu unrelated ones as Core or Qt)."
	}
    }
    $STATUS="ok" if $STATUS eq "skip";
}
exec {"repocop-test-$STATUS"} "repocop-test-$STATUS", @message;
EOF

%install
mkdir -p $RPM_BUILD_ROOT%_datadir/repocop/pkgtests/%testname/
%__install -m 755 test $RPM_BUILD_ROOT%_datadir/repocop/pkgtests/%testname/
#%__install -m 644 description $RPM_BUILD_ROOT%_datadir/repocop/pkgtests/%testname/

%files
%_datadir/repocop/pkgtests/%testname/test

%changelog
* Thu Apr 03 2008 Igor Vlasenko <viy@altlinux.ru> 0.05-alt1
- desktop-categories test is more verbose

* Tue Mar 25 2008 Igor Vlasenko <viy@altlinux.ru> 0.04-alt1
- fix for whitespaced filenames

* Mon Feb 25 2008 Igor Vlasenko <viy@altlinux.ru> 0.03-alt1
- First build for Sisyphus.
